package ist.palcom.hgraph.manager;

import ist.palcom.hgraph.AbstractListener;
import ist.palcom.hgraph.FuncHandler;
import ist.palcom.hgraph.Listener;
import ist.palcom.hgraph.Path;
import ist.palcom.hgraph.Value;
import ist.palcom.hgraph.XML;

public class LiveViewListener extends AbstractListener{

	public static final String name = "live view listener";
	public static final String description = "returns all triggered events, effectively giving a live view of the node";
	
	public LiveViewListener(Path returnPath){
		super(name, description, returnPath);
	}
	
	public void trigger(String command, Value value, Path callerPath){
		if(!command.equals(FuncHandler.CMD_ADDLISTENER) && ((Listener)value.getValue()).equals(this)){
			callback(LiveViewHandler.CMD_LIVE_VIEW_EVENT, new Value(command, value));
		}else{
			callback(LiveViewHandler.CMD_LIVE_VIEW_EVENT, new Value(LiveViewCallback.INITIAL_SYNC, XML.toXMLFull(node)));			
		}
	}
}
