package ist.palcom.discovery;

import ist.palcom.palcomthreads.Event;
import ist.palcom.resource.descriptor.LocalSID;

public class ServiceStatusEvent extends Event {

	private LocalSID localSID;
	
	private byte status;
	
	private String helpText;

	public ServiceStatusEvent(LocalSID localSID, byte status, String helpText) {
		this.localSID = localSID;
		this.status = status;
		this.helpText = helpText;
	}

	public LocalSID getLocalSID() {
		return localSID;
	}

	public byte getServiceStatus() {
		return status;
	}
	
	public String getServiceHelpText() {
		return helpText;
	}
}
